diff -pruN 20191020.git2908199-1/cl+ssl.asd 20200609.gitff4634a-1/cl+ssl.asd
--- 20191020.git2908199-1/cl+ssl.asd	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/cl+ssl.asd	2020-06-09 16:49:50.000000000 +0000
@@ -17,6 +17,7 @@
   :license "MIT"
   :author "Eric Marsden, Jochen Schmidt, David Lichteblau"
   :depends-on (:cffi :trivial-gray-streams :flexi-streams #+sbcl :sb-posix
+               #+(and sbcl win32) :sb-bsd-sockets
                :bordeaux-threads :trivial-garbage :uiop
                :alexandria :trivial-features)
   :serial t
diff -pruN 20191020.git2908199-1/debian/changelog 20200609.gitff4634a-1/debian/changelog
--- 20191020.git2908199-1/debian/changelog	2020-02-07 16:29:58.000000000 +0000
+++ 20200609.gitff4634a-1/debian/changelog	2020-12-04 10:41:07.000000000 +0000
@@ -1,3 +1,18 @@
+cl-plus-ssl (20200609.gitff4634a-1) unstable; urgency=medium
+
+  [ Sébastien Villemot ]
+  * New upstream snapshot
+  * Bump to debhelper 13
+  * Bump to S-V 4.5.1
+  * Add lintian-overrides for national-encoding in HTML documentation
+
+  [ Debian Janitor ]
+  * Trim trailing whitespace.
+  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
+    Repository-Browse.
+
+ -- Sébastien Villemot <sebastien@debian.org>  Fri, 04 Dec 2020 11:41:07 +0100
+
 cl-plus-ssl (20191020.git2908199-1) unstable; urgency=medium
 
   * New upstream snapshot
@@ -20,7 +35,7 @@ cl-plus-ssl (20180918.gitb81c113-1) unst
   * New upstream snapshot
   * Add Rules-Requires-Root: no
   * Bump S-V to 4.2.1
-  
+
  -- Sébastien Villemot <sebastien@debian.org>  Fri, 12 Oct 2018 23:40:24 +0200
 
 cl-plus-ssl (20180328-3) unstable; urgency=medium
diff -pruN 20191020.git2908199-1/debian/control 20200609.gitff4634a-1/debian/control
--- 20191020.git2908199-1/debian/control	2020-02-07 16:26:09.000000000 +0000
+++ 20200609.gitff4634a-1/debian/control	2020-12-04 10:39:06.000000000 +0000
@@ -3,10 +3,10 @@ Section: lisp
 Priority: optional
 Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
 Uploaders: Sébastien Villemot <sebastien@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                debhelper (>= 12.8~),
                libssl-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://common-lisp.net/project/cl-plus-ssl/
 Vcs-Git: https://salsa.debian.org/common-lisp-team/cl-plus-ssl.git
 Vcs-Browser: https://salsa.debian.org/common-lisp-team/cl-plus-ssl
diff -pruN 20191020.git2908199-1/debian/lintian-overrides 20200609.gitff4634a-1/debian/lintian-overrides
--- 20191020.git2908199-1/debian/lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 20200609.gitff4634a-1/debian/lintian-overrides	2020-12-04 10:40:39.000000000 +0000
@@ -0,0 +1,2 @@
+# This HTML file properly declares that it uses (legacy) encoding
+cl-plus-ssl: national-encoding usr/share/doc/cl-plus-ssl/index.html
diff -pruN 20191020.git2908199-1/debian/upstream/metadata 20200609.gitff4634a-1/debian/upstream/metadata
--- 20191020.git2908199-1/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
+++ 20200609.gitff4634a-1/debian/upstream/metadata	2020-04-03 08:16:57.000000000 +0000
@@ -0,0 +1,4 @@
+Bug-Database: https://github.com/cl-plus-ssl/cl-plus-ssl/issues
+Bug-Submit: https://github.com/cl-plus-ssl/cl-plus-ssl/issues/new
+Repository: https://github.com/cl-plus-ssl/cl-plus-ssl.git
+Repository-Browse: https://github.com/cl-plus-ssl/cl-plus-ssl
diff -pruN 20191020.git2908199-1/.gitattributes 20200609.gitff4634a-1/.gitattributes
--- 20191020.git2908199-1/.gitattributes	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/.gitattributes	2020-06-09 16:49:50.000000000 +0000
@@ -8,4 +8,4 @@
 # And it general, I don't like any magic conversions. Better
 # to work with files as they are.
 
-* text=false
\ No newline at end of file
+* -text
\ No newline at end of file
diff -pruN 20191020.git2908199-1/src/ffi-buffer-clisp.lisp 20200609.gitff4634a-1/src/ffi-buffer-clisp.lisp
--- 20191020.git2908199-1/src/ffi-buffer-clisp.lisp	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/src/ffi-buffer-clisp.lisp	2020-06-09 16:49:50.000000000 +0000
@@ -1,5 +1,35 @@
 ;;;; -*- Mode: LISP; Syntax: COMMON-LISP; indent-tabs-mode: nil; coding: utf-8; show-trailing-whitespace: t -*-
 
+;;;; CLISP speedup comments by Pixel / pinterface, 2007,
+;;;; copied from https://code.kepibu.org/cl+ssl/
+;;;;
+;;;; ## Speeding Up clisp
+;;;; cl+ssl has some serious speed issues on CLISP. For small requests,
+;;;; it's not enough to worry about, but on larger requests the speed
+;;;; issue can mean the difference between a 15 second download and a 15
+;;;; minute download. And that just won't do!
+;;;;
+;;;; ### What Makes cl+ssl on clisp so slow?
+;;;; On clisp, cffi's with-pointer-to-vector-data macro uses copy-in,
+;;;; copy-out semantics, because clisp doesn't offer a with-pinned-object
+;;;; facility or some other way of getting at the pointer to a simple-array.
+;;;; Very sad, I know. In addition to being a leaky abstraction, wptvd is really slow.
+;;;;
+;;;; ### How to Speed Things Up?
+;;;; The simplest thing that can possibly work: break the abstraction.
+;;;; I introduce several new functions (buffer-length, buffer-elt, etc.)
+;;;; and use those wherever an ssl-stream-*-buffer happens to be used,
+;;;; in place of the corresponding sequence functions.
+;;;; Those buffer-* functions operate on clisp's ffi:pointer objects,
+;;;; resulting in a tremendous speedup--and probably a memory leak or two.
+;;;;
+;;;; ### This Is Not For You If...
+;;;; While I've made an effort to ensure this patch doesn't break other
+;;;; implementations, if you have code which relies on ssl-stream-*-buffer
+;;;; returning an array you can use standard CL functions on, it will break
+;;;; on clisp under this patch. But you weren't relying on cl+ssl
+;;;; internals anyway, now were you?
+
 #+xcvb (module (:depends-on ("package" "reload" "conditions" "ffi" "ffi-buffer-all")))
 
 (in-package :cl+ssl)
diff -pruN 20191020.git2908199-1/src/ffi-buffer.lisp 20200609.gitff4634a-1/src/ffi-buffer.lisp
--- 20191020.git2908199-1/src/ffi-buffer.lisp	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/src/ffi-buffer.lisp	2020-06-09 16:49:50.000000000 +0000
@@ -5,7 +5,7 @@
 (in-package :cl+ssl)
 
 (defun make-buffer (size)
-  (cffi-sys::make-shareable-byte-vector size))
+  (cffi:make-shareable-byte-vector size))
 
 (defun buffer-length (buf)
   (length buf))
@@ -22,5 +22,5 @@
   (replace buf seq :start1 start1 :end1 end1 :start2 start2 :end2 end2))
 
 (defmacro with-pointer-to-vector-data ((ptr buf) &body body)
-  `(cffi-sys::with-pointer-to-vector-data (,ptr ,buf)
+  `(cffi:with-pointer-to-vector-data (,ptr ,buf)
     ,@body))
diff -pruN 20191020.git2908199-1/src/ffi.lisp 20200609.gitff4634a-1/src/ffi.lisp
--- 20191020.git2908199-1/src/ffi.lisp	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/src/ffi.lisp	2020-06-09 16:49:50.000000000 +0000
@@ -885,10 +885,10 @@ will use this value.")
 
 (defun init-prng (seed-byte-sequence)
   (let* ((length (length seed-byte-sequence))
-         (buf (cffi-sys::make-shareable-byte-vector length)))
+         (buf (cffi:make-shareable-byte-vector length)))
     (dotimes (i length)
       (setf (elt buf i) (elt seed-byte-sequence i)))
-    (cffi-sys::with-pointer-to-vector-data (ptr buf)
+    (cffi:with-pointer-to-vector-data (ptr buf)
       (rand-seed ptr length))))
 
 (defun ssl-ctx-set-session-cache-mode (ctx mode)
diff -pruN 20191020.git2908199-1/src/streams.lisp 20200609.gitff4634a-1/src/streams.lisp
--- 20191020.git2908199-1/src/streams.lisp	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/src/streams.lisp	2020-06-09 16:49:50.000000000 +0000
@@ -482,3 +482,37 @@ may be associated with the passphrase PA
 #+allegro
 (defmethod stream-fd ((stream stream))
   (socket:socket-os-fd stream))
+
+#+lispworks
+(defmethod stream-fd ((stream comm::socket-stream))
+  (comm:socket-stream-socket stream))
+
+#+abcl
+(progn
+  (require :abcl-contrib)
+  (require :jss)
+
+  ;;; N.b. Getting the file descriptor from a socket is not supported
+  ;;; by any published JVM API, so every JVM implementation may behave
+  ;;; somewhat differently.  By using the ability of
+  ;;; jss:get-java-fields to access private fields, it is usually
+  ;;; possible to "find" an access path to read the underlying integer
+  ;;; value of the file decriptor, which is all we need to pass to
+  ;;; SSL.
+  (defmethod stream-fd ((stream system::socket-stream))
+    (flet ((get-java-fields (object fields) ;; Thanks to Cyrus Harmon
+             (reduce (lambda (x y)
+                       (jss:get-java-field x y t))
+                     fields
+                     :initial-value object))
+           (jvm-version ()
+             (read
+              (make-string-input-stream
+               (java:jstatic "getProperty" "java.lang.System"
+                                          "java.specification.version")))))
+      (ignore-errors
+       (get-java-fields (java:jcall "getWrappedInputStream"  ;; TODO: define this as a constant
+                                    (two-way-stream-input-stream stream))
+                        (if (< (jvm-version) 14)
+                            '("in" "ch" "fdVal")
+                            '("in" "this$0" "sc" "fd" "fd")))))))
diff -pruN 20191020.git2908199-1/src/x509.lisp 20200609.gitff4634a-1/src/x509.lisp
--- 20191020.git2908199-1/src/x509.lisp	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/src/x509.lisp	2020-06-09 16:49:50.000000000 +0000
@@ -135,10 +135,19 @@ ASN1 string validation references:
     (decode-asn1-string asn1-string type)))
 
 (defun slurp-stream (stream)
-  (let ((seq (make-array (file-length stream) :element-type '(unsigned-byte 8))))
+  "Returns a sequence containing the STREAM bytes; the
+sequence is created by CFFI:MAKE-SHAREABLE-BYTE-VECTOR,
+therefore it can safely be passed to
+ CFFI:WITH-POINTER-TO-VECTOR-DATA."
+  (let ((seq (cffi:make-shareable-byte-vector (file-length stream))))
     (read-sequence seq stream)
     seq))
 
+(defgeneric decode-certificate (format bytes)
+  (:documentation
+   "The BYTES must be created by CFFI:MAKE-SHAREABLE-BYTE-VECTOR (because
+we are going to pass them to CFFI:WITH-POINTER-TO-VECTOR-DATA)"))
+
 (defmethod decode-certificate ((format (eql :der)) bytes)
   (cffi:with-pointer-to-vector-data (buf* bytes)
     (cffi:with-foreign-object (buf** :pointer)
diff -pruN 20191020.git2908199-1/.travis.yml 20200609.gitff4634a-1/.travis.yml
--- 20191020.git2908199-1/.travis.yml	2019-10-20 20:40:57.000000000 +0000
+++ 20200609.gitff4634a-1/.travis.yml	2020-06-09 16:49:50.000000000 +0000
@@ -1,6 +1,8 @@
 language: common-lisp
 sudo: false # lets try new infrastructure
-
+os: linux
+dist: bionic
+arch: amd64
 env:
   global:
     - PATH=~/.roswell/bin:$PATH
@@ -74,11 +76,10 @@ env:
     - LISP=allegro OPENSSL=libressl-2.6.5 BITS=32
     - LISP=allegro OPENSSL=libressl-2.8.3 BITS=32
     - LISP=allegro OPENSSL=libressl-3.0.1 BITS=32
-
 install:
   - curl -L https://raw.githubusercontent.com/snmsts/roswell/$ROSWELL_BRANCH/scripts/install-for-ci.sh | sh
   - test/run-on-many-lisps-and-openssls/openssl-releases/fetch.sh "$OPENSSL"
-  - if [ $BITS = 32 ]; then sudo apt-get install libc6-dev-i386; fi
+  - if [ $BITS = 32 ]; then sudo apt-get install libc6-dev-i386 gcc-multilib; fi
   - test/run-on-many-lisps-and-openssls/openssl-releases/build.sh "$OPENSSL" "$BITS" > openssl-build.log
 
 #  cache:
@@ -98,11 +99,26 @@ script:
                (format t \"(lisp-implementation-version): ~A~%\" (lisp-implementation-version))
                (format t \"*features*: ~A~%\" *features*)
                (format t \"(asdf:asdf-version): ~A~%\" (asdf:asdf-version)))'
+         -e '#+abcl
+             (progn
+                (format t \"Loading abcl-asdf and switching maven repo URL to HTTPS (see https://github.com/armedbear/abcl/issues/151)~%\")
+                (require :abcl-contrib)
+                (format t \"abcl-contrib loaded...~%\")
+                (require :abcl-asdf)
+                (format t \"abcl-asdf loaded...~%\")
+                (format t \"*features*: ~A~%\" *features*)
+                (setf (symbol-value (read-from-string \"abcl-asdf::*default-repository*\"))
+                      \"https://repo1.maven.org/maven2/\")
+                (format t \"abcl-asdf::*default-repository* assigned the HTTPS URL.~%\"))'
          -e '(ql:quickload :cffi)'
+         -e '(format t \"cffi loaded.~%\")'
          -e '(cffi:load-foreign-library \"test/run-on-many-lisps-and-openssls/openssl-releases/bin/'$OPENSSL-${BITS}bit'/lib/libcrypto.so\")'
+         -e '(format t \"libcrypto.so loaded.~%\")'
          -e '(cffi:load-foreign-library \"test/run-on-many-lisps-and-openssls/openssl-releases/bin/'$OPENSSL-${BITS}bit'/lib/libssl.so\")'
+         -e '(format t \"libssl.so loaded.~%\")'
          -e '(pushnew :cl+ssl-foreign-libs-already-loaded *features*)'
          -e '(ql:quickload :cl+ssl) ;; load cl+ssl separately from cl+ssl.test only because cl+ssl.test can not be loaded in the :invert readtable-case due to its dependency ironclad, as of 2019-10-20'
+         -e '(format t \"cl+ssl loaded.~%\")'
          -e '(when (uiop:getenvp \"READTABLE_CASE_INVERT\")
                (format t \"restoring readtable-case to :upcase before loading cl+ssl.test~%\")
                (setf (readtable-case *readtable*) :upcase))'
